-- firstly make sure that temp tables are empty, and then drop them
begin
    execute immediate 'truncate table cdb_api_params';
    execute immediate 'truncate table tmp_item_props';
    execute immediate 'drop index tip_dpe_idx';
    execute immediate 'drop INDEX tip_ipropd_idx';
    execute immediate 'delete from tmp_item_props';
    execute immediate 'delete from CDB_API_PARAMS';

exception 
    when others then 
	if sqlcode = -00942 then null; 
	elsif sqlcode = -01418 then null; 
    else raise; 
    end if;
end;
/


declare 
    readerRole	varchar2(30);
    writerRole	varchar2(30);
begin

readerRole:='r_fwConfR_'||USER;
writerRole:='r_fwConfW_'||USER;



begin
    execute immediate 'drop role '||readerRole;
    execute immediate 'drop role '||writerRole;
exception when others then if sqlcode = -01919 then null; else raise; end if;
end;

begin
    execute immediate 'DROP PACKAGE fwConfigurationDB';
exception when others then if sqlcode = -04043 then null; else raise; end if;
end;

    
begin
    execute immediate 'drop type sumAlertTableType';
    execute immediate 'drop type sumAlertObject';
exception when others then if sqlcode = -04043 then null; else raise; end if;
end;

begin
    execute immediate 'DROP VIEW  v_recipesAll CASCADE CONSTRAINTS';
    execute immediate 'DROP TABLE recipe_tags CASCADE CONSTRAINTS';
    execute immediate 'DROP TABLE recipe_data CASCADE CONSTRAINTS';
    execute immediate 'DROP TABLE recipe_versions CASCADE CONSTRAINTS';
    execute immediate 'DROP TABLE recipes CASCADE CONSTRAINTS';
    execute immediate 'DROP TABLE references CASCADE CONSTRAINTS';

    execute immediate 'DROP TABLE tmp_item_props';
    execute immediate 'DROP TABLE CDB_API_PARAMS';

    execute immediate 'DROP VIEW V_REFERENCES';
    execute immediate 'DROP VIEW V_CONFIG_ITEMS';
    execute immediate 'DROP VIEW V_CONFIG_ALERTS';
    execute immediate 'DROP VIEW V_DEVICE_CONFIGS';
    execute immediate 'DROP VIEW V_DEVICE_CONFIGS_ALL';
    execute immediate 'DROP VIEW V_ITEM_PROPERTIES';
exception when others then if sqlcode = -00942 then null; else raise; end if;
end;

begin
    execute immediate 'DROP FUNCTION LSTAGG';
    execute immediate 'DROP FUNCTION LSTAGGNUM';
    execute immediate 'DROP TYPE LIST_AGG_TYPE';
exception when others then if sqlcode = -04043 then null; else raise; end if;
end;

begin
    execute immediate 'DROP TABLE CONFIG_GENERAL CASCADE CONSTRAINTS';
    execute immediate 'DROP TABLE CONFIG_UF CASCADE CONSTRAINTS';
    execute immediate 'DROP TABLE CONFIG_SMOOTHING CASCADE CONSTRAINTS';
    execute immediate 'DROP TABLE CONFIG_PVRANGES CASCADE CONSTRAINTS';
    execute immediate 'DROP TABLE CONFIG_CONVERSIONS CASCADE CONSTRAINTS';
    execute immediate 'DROP TABLE CONFIG_DPFUNCTIONS CASCADE CONSTRAINTS';
    execute immediate 'DROP TABLE CONFIG_ARCHIVING CASCADE CONSTRAINTS';
    execute immediate 'DROP TABLE CONFIG_ADDRESSES CASCADE CONSTRAINTS';
    execute immediate 'DROP TABLE CONFIG_SUMALERTS CASCADE CONSTRAINTS';
    execute immediate 'DROP TABLE CONFIG_DPEALERTS CASCADE CONSTRAINTS';
    execute immediate 'DROP TABLE CONFIG_ALERTS_MISC CASCADE CONSTRAINTS';
    execute immediate 'DROP TABLE CONFIG_ALERTS CASCADE CONSTRAINTS';
    execute immediate 'DROP TABLE CONFIG_VALUES_BIG CASCADE CONSTRAINTS';
    execute immediate 'DROP TABLE CONFIG_VALUES CASCADE CONSTRAINTS';
    execute immediate 'DROP TABLE CONFIG_DESC CASCADE CONSTRAINTS';
    execute immediate 'DROP TABLE CONFIG_ITEMPROPS CASCADE CONSTRAINTS';
    execute immediate 'DROP TABLE CONFIG_ITEMS_NEW CASCADE CONSTRAINTS';
    execute immediate 'DROP TABLE DEVICE_TYPES CASCADE CONSTRAINTS';
    execute immediate 'DROP TABLE DEVICE_ELEMENTS CASCADE CONSTRAINTS';

    execute immediate 'DROP TABLE OLD_CONFIG_ITEM_PROPERTIES CASCADE CONSTRAINTS';
    execute immediate 'DROP TABLE OLD_CONFIG_TAGS CASCADE CONSTRAINTS';
    execute immediate 'DROP TABLE OLD_CONFIG_ITEMS CASCADE CONSTRAINTS';
exception when others then if sqlcode = -00942 then null; else raise; end if;
end;

begin
    execute immediate 'DROP SEQUENCE CONF_ID_SEQ';
    execute immediate 'DROP SEQUENCE CITEM_ID_SEQ';
    execute immediate 'DROP SEQUENCE DEVELEM_ID_SEQ';
    execute immediate 'DROP SEQUENCE DPT_ID_SEQ';
    execute immediate 'DROP SEQUENCE IPROP_ID_SEQ';
    execute immediate 'DROP SEQUENCE items_id_seq';
    execute immediate 'DROP SEQUENCE RECIPES_RVER_SEQ';
    execute immediate 'DROP SEQUENCE RECIPES_TAGID_SEQ';
    execute immediate 'DROP SEQUENCE recipe_data_propid_seq';
exception when others then if sqlcode = -02289 then null; else raise; end if;
end;

begin
    execute immediate 'DROP TABLE items CASCADE CONSTRAINTS';
    execute immediate 'DROP TABLE hierarchies CASCADE CONSTRAINTS';
    execute immediate 'DROP VIEW  v_confdb CASCADE CONSTRAINTS';
exception when others then if sqlcode = -00942 then null; else raise; end if;
end;

end;
/
